<?php

// ntlm.php
// last modified <10:40:39 JST 01/31/2007  Shunji Kawabata>

// Copyright (c) 2007 Shunji Kawabata

// version: 0.1
// revision: 2
// author: Shunji Kawabata <kwbt[at]ra3[dot]so-net[dot]ne[dot]jp>

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Inspired by PHP NTLM GET LOGIN, originally written by Nicolas GOLLET.


session_start();

$headers = apache_request_headers();

if( @$_SERVER['HTTP_VIA'] != NULL ) {
  // when user accessed via proxy ...
  // go basic auth or something??
  echo "proxy bypassed.";
}
else if( $headers['Authorization'] == NULL ) {
  // first handshake
  header( "HTTP/1.0 401 Unauthorized" );
  header( "WWW-Authenticate: NTLM" );
  exit;
}

if( isset( $headers['Authorization'] ) ) {
  if( substr( $headers['Authorization'],0,5 ) == 'NTLM ' ) {
    $chaine = $headers['Authorization'];
    $chaine = substr( $chaine, 5 );
    $chained64 = base64_decode( $chaine );
    if( ord( $chained64{8} ) == 1 ) {
    // when received type1-message, returns type2-message
      $retAuth = "NTLMSSP".chr(000).chr(002).chr(000).chr(000).chr(000).chr(000).chr(000).chr(000);
      $retAuth .= chr(000).chr(040).chr(000).chr(000).chr(000).chr(001).chr(130).chr(000).chr(000);
      $retAuth .= chr(000).chr(002).chr(002).chr(002).chr(000).chr(000).chr(000).chr(000).chr(000);
      $retAuth .= chr(000).chr(000).chr(000).chr(000).chr(000).chr(000).chr(000);
      $retAuth64 = base64_encode( $retAuth );
      $retAuth64 = trim( $retAuth64 );

      // second handshake
      header( "HTTP/1.0 401 Unauthorized" );
      header( "WWW-Authenticate: NTLM $retAuth64" );
      exit;
    }
    else if( ord($chained64{8}) == 3 ) {
      // when received type3-message
      $length_remotehost = ( ord( $chained64[47] ) * 256 + ord( $chained64[46] ) );
      $offset_remotehost = ( ord( $chained64[49] ) * 256 + ord( $chained64[48] ) );
      $remotehost = str_replace( "\0","",substr( $chained64, $offset_remotehost, $length_remotehost ) );
      $length_domain = ( ord( $chained64[31] ) * 256 + ord( $chained64[30] ) );
      $offset_domain = ( ord( $chained64[33] ) * 256 + ord( $chained64[32] ) );
      $domain = str_replace( "\0","",substr( $chained64, $offset_domain, $length_domain ) );
      $length_login = ( ord( $chained64[39] ) * 256 + ord( $chained64[38] ) );
      $offset_login = ( ord( $chained64[41] ) * 256 + ord( $chained64[40] ) );
      $login = str_replace( "\0","",substr( $chained64, $offset_login, $length_login ) );
      if ( $login != NULL ) {
	echo "User: ";
	echo $login;
	echo "</br>";
	echo "Domain: ";
	echo $domain;
	echo "</br>";
	echo "RemoteHost: ";
	echo $remotehost;
	echo "</br>";
      }
      else {
	echo "NTLM User name is empty.";
      }
    }
  }
}

?>
